Package net.sf.saxon.lib

## Class StandardEntityResolver

- java.lang.Object
- - net.sf.saxon.lib.StandardEntityResolver

- All Implemented Interfaces:
    `org.xml.sax.EntityResolver`

      public class StandardEntityResolver
      extends java.lang.Object
      implements org.xml.sax.EntityResolver

  This class is an EntityResolver used to resolve references to common DTDs and entity files, using local copies provided with the Saxon product. It has become necessary to do this because W3C is no longer serving these files from its server. Ideally the job of caching these files would belong to the XML parser, but because many of the parsers were issued years ago, they cannot be relied on to do it.

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `Configuration` | `config` |

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `StandardEntityResolver​(Configuration config)` |

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `static org.xml.sax.InputSource` | `fetch​(java.lang.String filename, Configuration config)` | Get the source from a given file.
    `protected org.xml.sax.InputSource` | `getResource​(java.lang.String resourceName, Configuration config)` | Get a resource from the classpath.
    `static void` | `register​(java.lang.String publicId, java.lang.String systemId, java.lang.String fileName)` | Register a DTD or other entity to be resolved by this entity resolver
    `org.xml.sax.InputSource` | `resolveEntity​(java.lang.String publicId, java.lang.String systemId)` | Allow the application to resolve external entities.
    `void` | `setConfiguration​(Configuration config)` | Set configuration details.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### config

          public Configuration config

  - ### Constructor Detail

    - #### StandardEntityResolver

          public StandardEntityResolver​(Configuration config)

  - ### Method Detail

    - #### register

          public static void register​(java.lang.String publicId,
                                      java.lang.String systemId,
                                      java.lang.String fileName)

      Register a DTD or other entity to be resolved by this entity resolver
      Parameters:
        `publicId` - the public identifier of the DTD or entity
        `systemId` - the system identifier of the DTD or entity. For domains that are known to redirect http: to https:, either scheme is accepted.
        `fileName` - the fileName of the Saxon local copy of the resource, relative to the data directory in the JAR file

    - #### setConfiguration

          public void setConfiguration​(Configuration config)

      Set configuration details. This is used to control tracing of accesses to files
      Parameters:
        `config` - the Saxon configuration

    - #### resolveEntity

          public org.xml.sax.InputSource resolveEntity​(java.lang.String publicId,
                                                       java.lang.String systemId)
                                                throws org.xml.sax.SAXException

      Allow the application to resolve external entities.

      The parser will call this method before opening any external entity except the top-level document entity. Such entities include the external DTD subset and external parameter entities referenced within the DTD (in either case, only if the parser reads external parameter entities), and external general entities referenced within the document element (if the parser reads external general entities). The application may request that the parser locate the entity itself, that it use an alternative URI, or that it use data provided by the application (as a character or byte input stream).

      Application writers can use this method to redirect external system identifiers to secure and/or local URIs, to look up public identifiers in a catalogue, or to read an entity from a database or other input source (including, for example, a dialog box). Neither XML nor SAX specifies a preferred policy for using public or system IDs to resolve resources. However, SAX specifies how to interpret any InputSource returned by this method, and that if none is returned, then the system ID will be dereferenced as a URL.

      If the system identifier is a URL, the SAX parser must resolve it fully before reporting it to the application.

      Specified by:
        `resolveEntity` in interface `org.xml.sax.EntityResolver`
      Parameters:
        `publicId` - The public identifier of the external entity being referenced, or null if none was supplied.
        `systemId` - The system identifier of the external entity being referenced.
      Returns:
        An InputSource object describing the new input source, or null to request that the parser open a regular URI connection to the system identifier.
      Throws:
        `org.xml.sax.SAXException` - Any SAX exception, possibly wrapping another exception.
      See Also:
        `InputSource`

    - #### fetch

          public static org.xml.sax.InputSource fetch​(java.lang.String filename,
                                                      Configuration config)

      Get the source from a given file.
      Parameters:
        `filename` - the name of the file
        `config` - the Saxon Configuration
      Returns:
        an InputSource representing the contents of the file.

    - #### getResource

          protected org.xml.sax.InputSource getResource​(java.lang.String resourceName,
                                                        Configuration config)

      Get a resource from the classpath. This method is called if the URI uses the (Spring-defined) "classpath" URI scheme. It attempts to locate the resource on the classpath and returns an InputSource containing the relevant InputStream. If the inputstream cannot be located, it returns null. A subclass that does not want classpath URIs to be resolved in this way should override this method to return null unconditionally.
      Parameters:
        `resourceName` - the resource to be fetched from the classpath
        `config` - the Saxon Configuration object
      Returns:
        an InputSource representing the named resource (fetched from the classpath) or null if no resource is available.